<script type="text/html" data-help-name="dim-xml-state-server">
  <p>
    A DIM-XML Server node providing a State service to describe a state
    machine.
  </p>
  <h3>Inputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">object</span></dt>
    <dd>
      The input value that can trigger state changes.<br>
      If this property is not set, nothing will be changed.
    </dd>
  </dl>
  <h3>Outputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">object</span></dt>
    <dd>
      The updated service value sent to subscribed clients.<br>
      For details, see <code>DIM-XML State Client</code> node.
    </dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node registers a <i>State</i> service on a DIM Name Server (DNS). A
    connection to the DNS Server is required for this purpose, which can be
    created by clicking on the pencil icon or selecting an existing one shared
    between several DIM-XML nodes.
  </p>
  <p>
    The service is identified by the <i>Service Name</i> which must be unique
    for a given DNS Server and comply the following
    <a target="_blank" href="https://www.rfc-editor.org/info/rfc5234">
      abnf syntax
    </a>:
    <pre><b>part *( "/" part )</b>
      <br>part = (ALPHA / DIGIT) *body
      <br>body = (ALPHA / DIGIT / "-" / "+" / "_" / "." / ":")</pre>
    For example:
    <pre>/state/service/name</pre>
  </p>
  <p>
    The state machine can be described using the <i>States</i> list, ordered by
    value. Whenever a new state is added, the <b>Value</b> field is pre-filled
    with the consecutive integer of the maximum value, but it can be edited.<br>
    Finally, an <i>Initial state</i> is requered to configure the node properly.
  </p>
  <p>
    The input value can have the following <i>optional</i> properties:
    <ul>
      <li>
        <code>state</code>, an integer representing the state to set. An error
        is raised if it does not match one of the possible states defined.
      </li>
      <li>
        <code>error</code>, an object reporting an active error. It must
        contain <b>code</b> (an integer identifying the error) and optionally
        <b>message</b> describing the error. For example:
        <pre>{ code: 500, message: "Error" }</pre>
      </li>
      <li>
        <code>errors</code>, the list of errors to set. It consists of an array
        of the above error objects. The error list is not affected if one of
        the errors in the array is not correctly defined.<br>
        In addition, errors are reset either when a valid state is set or by
        sending an empty array.
      </li>
      <li>
        <code>warning</code>, an object reporting an active warning. It must
        contain <b>code</b> (an integer identifying the warning) and optionally
        <b>message</b> describing the warning. For example:
        <pre>{ code: 800, message: "Warning" }</pre>
      </li>
      <li>
        <code>warnings</code>, the list of warnings to set. It consists of an
        array of the above warning objects. The warnings list is not affected
        if one of the warnings in the array is not correctly defined.<br>
        It is also possible to reset warnings by sending an empty array.
      </li>
    </ul>
  </p>
</script>
